(define (int-then-list x)
  (if (integer? x)
      (list x)
      #f))

(define (fn x)
  (cond
   ((unspecified? x))
   ((int-then-list x) => car)
   ((boolean? x)
    (not x))
   (else x)))

(test-group
  (eq? #t (fn *unspecified*))
  (eqv? 4 (fn 4))
  (eq? #t (fn #f))
  (eq? #f (fn #t))
  (equal? "abc" (fn "abc"))
  (unspecified? (cond)))
