(define-syntax test-macro
  (lambda (sintax)
    (syntax-case sintax ()
      ((test-macro ident)
       (list #'quote
             (list
               (free-identifier=? #'ident #'some-ident)
               (bound-identifier=? #'ident #'some-ident)))))))

(test-group
  (bound-identifier=? #'unbound #'unbound)
  (bound-identifier=? #'car #'car)
  (not (bound-identifier=? #'unbound #'unbound2))
  (not (bound-identifier=? #'car #'cdr))
  (not (bound-identifier=? #'unbound (let ((unbound 5)) #'unbound)))
  (not (bound-identifier=? #'car (let ((car 5)) #'car)))
  (equal? (test-macro some-ident) '(#t #f)))

