(test-group
  (let ((val '(1 . 2)))
    (eq? val val))
  (let ((val1 '(1 . 2))
        (val2 '(2 . 3)))
    (not (eq? val1 val2)))
  (not (eq? 1 2))
  ;; Quote expression always returns the same value
  (let ((fun (lambda () '(1 . 2))))
    (eq? (fun) (fun)))
  ;; cons calls always return different values
  (let ((fun (lambda () (cons 1 2))))
    (not (eq? (fun) (fun)))))
